/*
Copyright (C) 2003 Hotsprings Inc.
For conditions of distribution and use, see copyright notice

Location: 
	www.HotspringsInc.com 

History:
	2003Aug27-GiuseppeG: code write
*/

namespace XSP
{
class ImagePool;
class ImageView : public View
{
	OffscreenImage image;
	bool withinDND;

	refc<ImagePool> imageLoader;
	FileName		filename;
	
public:
	ImageView();
	void SetImage(const OffscreenImage& img);
	void SetImage(const OffscreenImage& img, const FileName& fnm);
	void LoadNewImage(const FileName& filename);
protected:
	~ImageView();
	virtual void Draw(Graphics& g, const Rect2D& area);
	virtual void HandleDrop(DragDropType::TypeSet& availableTypes, 
						  DragDropType::Effect&  effect,
						  const Point2D& 		 mousePos,
						  bool 					 onlySimulate,
						  DragDropType::FatData& fatData );
	virtual bool HandleMouseEvent( const UIEvent& ev );
};

} // namespace XSP
